/**
 * Copyright (c) 2011-2012 EBM WebSourcing, 2012-2015 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.component.framework.junit.impl.message;

import javax.jbi.messaging.ExchangeStatus;
import javax.jbi.messaging.MessageExchange;
import javax.jbi.messaging.MessageExchange.Role;
import javax.jbi.messaging.MessagingException;
import javax.xml.transform.Source;

import org.ow2.petals.component.framework.junit.ResponseMessage;

import com.ebmwebsourcing.easycommons.lang.UncheckedException;

/**
 * TODO There is only one possible status here: DONE
 * 
 * TODO We should create another ResponseMessage for ERROR!
 * 
 * @author Christophe DENEUX - Linagora
 */
public class WrappedStatusToConsumerMessage extends AbstractWrappedToComponentMessage implements ResponseMessage {

    public WrappedStatusToConsumerMessage(final MessageExchange messageExchange, final ExchangeStatus status) {
        super(messageExchange);

        try {
            this.messageExchange.setRole(Role.PROVIDER);

            this.messageExchange.setStatus(status);

            this.messageExchange.setRole(Role.CONSUMER);
        } catch (final MessagingException e) {
            throw new UncheckedException("Impossible to create a message exchange", e);
        }
    }

    @Override
    public Source getPayload() {
        throw new UnsupportedOperationException();
    }

    @Override
    public Source getFault() {
        throw new UnsupportedOperationException();
    }

    @Override
    public Exception getError() {
        throw new UnsupportedOperationException();
    }
}
